"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRootDir = exports.getCommitHash = exports.getRemoteUrl = exports.getCurrentBranch = exports.getUserName = exports.getUserEmail = void 0;
const simple_git_1 = require("simple-git");
function getUserEmail() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const userEmail = yield (0, simple_git_1.simpleGit)().raw(['config', 'user.email']);
            return userEmail.trim();
        }
        catch (error) {
            //
        }
    });
}
exports.getUserEmail = getUserEmail;
function getUserName() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const userName = yield (0, simple_git_1.simpleGit)().raw(['config', 'user.name']);
            return userName.trim();
        }
        catch (error) {
            //
        }
    });
}
exports.getUserName = getUserName;
function getCurrentBranch() {
    return __awaiter(this, void 0, void 0, function* () {
        if (process.env.VERCEL_GIT_COMMIT_REF) {
            return process.env.VERCEL_GIT_COMMIT_REF;
        }
        try {
            const branches = yield (0, simple_git_1.simpleGit)().branch();
            return branches.current;
        }
        catch (error) {
            //
        }
    });
}
exports.getCurrentBranch = getCurrentBranch;
function getRemoteUrl() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const remoteUrl = yield (0, simple_git_1.simpleGit)().raw(['remote', 'get-url', 'origin']);
            return remoteUrl.trim();
        }
        catch (error) {
            //
        }
    });
}
exports.getRemoteUrl = getRemoteUrl;
function getCommitHash() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const commitHash = yield (0, simple_git_1.simpleGit)().raw(['rev-parse', 'HEAD']);
            return commitHash.trim();
        }
        catch (error) {
            //
        }
    });
}
exports.getCommitHash = getCommitHash;
function getRootDir() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const gitRootDir = (yield (0, simple_git_1.simpleGit)().raw(['rev-parse', '--show-toplevel'])).trim();
            return gitRootDir;
        }
        catch (error) {
            //
        }
    });
}
exports.getRootDir = getRootDir;
