"use strict";
const path_1 = require("path");
// TODO: use options (appId)
function nextInItStats({ legacy = false, outDir = './in-it-stats', serverUrl = 'https://in-it.nissix.com/api/stats', name, } = {}) {
    return (nextConfig = {}) => {
        // if in dev mode and not requested explicitly
        if (process.env.NODE_ENV !== 'production' && process.env.ANALYZE !== 'true') {
            return nextConfig;
        }
        const nextConfigWithInItStats = Object.assign(Object.assign({}, nextConfig), { webpack(config, options) {
                var _a, _b;
                if (!legacy) {
                    throw new Error('next-in-it-stats: modern mode is not supported yet');
                }
                let reportFilename;
                if (outDir.startsWith('.')) {
                    reportFilename = (0, path_1.join)(process.cwd(), options.config.distDir, outDir, `${(_a = options.nextRuntime) !== null && _a !== void 0 ? _a : 'client'}.json`);
                }
                else {
                    reportFilename = (0, path_1.join)(outDir, `${(_b = options.nextRuntime) !== null && _b !== void 0 ? _b : 'client'}.json`);
                }
                // eslint-disable-next-line @typescript-eslint/no-var-requires
                const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin;
                // eslint-disable-next-line @typescript-eslint/no-var-requires
                const InItStatsWebpackPlugin = require('./InItStatsWebpackPlugin').default;
                config.plugins.push(new BundleAnalyzerPlugin({
                    // analyzerMode: 'static',
                    // openAnalyzer: true,
                    // reportFilename: `${reportFilename}.html`,
                    analyzerMode: 'json',
                    reportFilename,
                    logLevel: 'silent',
                }), new InItStatsWebpackPlugin({
                    serverUrl,
                    reportFilename,
                    buildId: options.buildId,
                    outDir: (0, path_1.join)(process.cwd(), options.config.distDir),
                    name,
                }));
                if (typeof nextConfig.webpack === 'function') {
                    return nextConfig.webpack(config, options);
                }
                return config;
            } });
        return nextConfigWithInItStats;
    };
}
exports.default = nextInItStats;
module.exports = nextInItStats;
